#ifndef	CHORD_H
#define CHORD_H

#include <string>
using namespace std;

class chord
{
	private:
		unsigned char root;
		/*====================
		bit-wise:
		****XXXX
		*=octave (0-15)
		X=note

		pitch(freq)			binary	  root   oct+note	  midi_id

		A0 (27.5hz)		= 0000 0101	= 0		= 0 + 9		= midi 21
		...
		C1 (32.7hz)		= 0001 0000	= 32	= 32 + 0	= midi 24
		A1 (55hz)		= 0001 0101	= 41	= 32 + 9	= midi 33
		...
		C4 (261.6hz)	= 0100 0000	= 128	= 128 + 0	= midi 60
		A4 (440hz)		= 0100 0101	= 137	= 128 + 9	= midi 69
		...
		C8 (4816hz)		= 1000 0000	= 156	= 156 + 0	= midi 108


		note = root%16
		octave = floor(root/16)
		midi=octave*12+note+12
		root=octave*16+note
		====================*/
		unsigned char standard;
		/*====================
		bit-wise:
		*II(&&%#
		*=extension
		(=9th	0=none,		1=add9
		&=7th	00=none,	01=N/A, 10=major, 11=minor
		%=5th	0=perfect,	1=augmented
		#=3rd	0=major,	1=minor
		I=Inversion (chooses which note is the bass note)
			00=none, 01=first, 10=second, 11=third
		*=other 0=no custom	1=custom
		====================*/
		unsigned char extension;
		/*===================
		will populate this list as needed
		===================*/
		void makenotes(unsigned char root,unsigned char standard=0, unsigned char extension=0);
	public:
		string notes;
		/*====================
		holds the values for the midi notes
		=====================*/

		chord(char octave, char note, unsigned char standard, unsigned char extension);
		chord::chord(char octave, char note, char _3rd, char _5th, char _7th, char _9th, char inv, unsigned char extension);
};
#endif
